import 'package:flutter/services.dart';
import 'package:plugin_platform_interface/plugin_platform_interface.dart';
import 'src/method_channel_aliyun_oss.dart';

export 'src/method_channel_aliyun_oss.dart';
export 'src/event_channel_aliyun_oss.dart';
export 'constants.dart';

class AliyunOSSPlatform extends PlatformInterface {
  AliyunOSSPlatform() : super(token: _token);

  static final Object _token = Object();
  OSSStsTokenCredentialProvider? provider;

  static AliyunOSSPlatform _instance = MethodChannelAliyunOSS();
  static AliyunOSSPlatform get instance => _instance;

  static set instance(AliyunOSSPlatform instance) {
    PlatformInterface.verify(instance, _token);
    _instance = instance;
  }

  Future<String?> getPlatformVersion() {
    throw UnimplementedError('getPlatformVersion() has not been implemented.');
  }

  init(String endpoint, OSSCredentialProvider provider) {
    throw UnimplementedError('init() has not been implemented.');
  }

  Future<dynamic> putObject(String bucketName) {
    throw UnimplementedError('putObject() has not been implemented.');
  }

  void setMethodCallHandler(Future<dynamic> Function(MethodCall call)? handler) {
    throw UnimplementedError('setMethodCallHandler() has not been implemented.');
  }
}
