import 'package:flutter/services.dart';

const EventChannel _eventChannel = EventChannel('com.wombat/aliyun_oss_stream_plugin');

typedef Listener = void Function(dynamic msg);
typedef CancelListening = void Function();

int nextListenerId = 1;
CancelListening startListening(Listener listener) {
  var subscription = _eventChannel
      .receiveBroadcastStream(nextListenerId++)
      .listen(listener, cancelOnError: true);

  return () => subscription.cancel();
}
